﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TripleTriHard
{
    public class BoardSlot
    {
        public int SlotNumber { get; set; }
        public Card Card { get; set; }

        public BoardSlot TopConnection { get; set; }
        public BoardSlot LeftConnection { get; set; }
        public BoardSlot RightConnection { get; set; }
        public BoardSlot BottomConnection { get; set; }

        public BoardSlot(int slot)
        {
            SlotNumber = slot;
        }

        public bool IsOpen()
        {
            return Card.HAVECARD == 0;
        }

        public bool IsCardValid { get; set; }

        public override string ToString()
        {
            return "Slot #" + SlotNumber + ", Card| " + Card.ToString();
        }

        public override bool Equals(object obj)
        {
            if (obj == null) return false;
            if (this.GetType() != obj.GetType()) return false;
            var boardSlot = obj as BoardSlot;
            return boardSlot != null && SlotNumber == boardSlot.SlotNumber;
        }
    }
}
