﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace TripleTriHard
{

#if RB_64
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct Card
    {
        private byte byte0;
        private byte byte1;
        private byte byte2;
        private byte byte3;
        private byte byte4;
        private byte byte5;
        private byte byte6;
        private byte byte7;
        private byte byte8;
        private byte byte9;
        private byte byteA;
        private byte byteB;
        private byte byteC;
        private byte byteD;
        private byte byteE;
        private byte byteF;
        private byte byte10;
        private byte byte11;
        private byte byte12;
        private byte byte13;
        private byte byte14;
        private byte byte15;
        private byte byte16;
        private byte byte17;
        private byte byte18;
        private byte byte19;
        private byte byte1A;
        private byte byte1B;
        private byte byte1C;
        private byte byte1D;
        private byte byte1E;
        private byte byte1F;
        private byte byte20;
        private byte byte21;
        private byte byte22;
        private byte byte23;
        private byte byte24;
        private byte byte25;
        private byte byte26;
        private byte byte27;
        private byte byte28;
        private byte byte29;
        private byte byte2A;
        private byte byte2B;
        private byte byte2C;
        private byte byte2D;
        private byte byte2E;
        private byte byte2F;
        private byte byte30;
        private byte byte31;
        private byte byte32;
        private byte byte33;
        private byte byte34;
        private byte byte35;
        private byte byte36;
        private byte byte37;
        private byte byte38;
        private byte byte39;
        private byte byte3A;
        private byte byte3B;
        private byte byte3C;
        private byte byte3D;
        private byte byte3E;
        private byte byte3F;
        private byte byte40;
        private byte byte41;
        private byte byte42;
        private byte byte43;
        private byte byte44;
        private byte byte45;
        private byte byte46;
        private byte byte47;
        private byte byte48;
        private byte byte49;
        private byte byte4A;
        private byte byte4B;
        private byte byte4C;
        private byte byte4D;
        private byte byte4E;
        private byte byte4F;
        private byte byte50;
        private byte byte51;
        private byte byte52;
        private byte byte53;
        private byte byte54;
        private byte byte55;
        private byte byte56;
        private byte byte57;
        private byte byte58;
        private byte byte59;
        private byte byte5A;
        private byte byte5B;
        private byte byte5C;
        private byte byte5D;
        private byte byte5E;
        private byte byte5F;
        private byte byte60;
        private byte byte61;
        private byte byte62;
        private byte byte63;
        private byte byte64;
        private byte byte65;
        private byte byte66;
        private byte byte67;
        private byte byte68;
        private byte byte69;
        private byte byte6A;
        private byte byte6B;
        private byte byte6C;
        private byte byte6D;
        private byte byte6E;
        private byte byte6F;
        private byte byte70;
        private byte byte71;
        private byte byte72;
        private byte byte73;
        private byte byte74;
        private byte byte75;
        private byte byte76;
        private byte byte77;
        private byte byte78;
        private byte byte79;
        private byte byte7A;
        private byte byte7B;
        private byte byte7C;
        private byte byte7D;
        private byte byte7E;
        private byte byte7F;
        public byte STARS;
        private byte byte81;
        public byte OWNER;
        public byte TOP;
        public byte BOTTOM;
        public byte LEFT;
        public byte RIGHT;
        private byte byte87;
        private byte byte88;
        private byte byte89;
        private byte byte8A;
        private byte byte8B;
        private byte byte8C;
        private byte byte8D;
        private byte byte8E;
        private byte byte8F;
        private byte byte90;
        private byte byte91;
        private byte byte92;
        private byte byte93;
        private byte byte94;
        private byte byte95;
        private byte byte96;
        private byte byte97;
        private byte byte98;
        private byte byte99;
        private byte byte9A;
        private byte byte9B;
        public sbyte ASCENSION;
        private byte byte9D;
        private byte byte9E;
        private byte byte9F;
        private byte byteA0;
        private byte byteA1;
        private byte byteA2;
        private byte byteA3;
        public byte HAVECARD;
        private byte byteA5;
        private byte byteA6;
        private byte byteA7;



        public int this[string var]
        {
            get
            {
                switch (var)
                {
                    case "TOP":
                        return TOP;
                    case "BOTTOM":
                        return BOTTOM;
                    case "LEFT":
                        return LEFT;
                    case "RIGHT":
                        return RIGHT;
                    default:
                        return HAVECARD;
                }
            }
        }

        public int AdjustedTop
        {
            get
            {
                if ((TOP + ASCENSION) > 10)
                {
                    return 10;
                }
                return TOP + ASCENSION;
            }
        }

        public int AdjustedLeft
        {
            get
            {
                if ((LEFT + ASCENSION) > 10)
                {
                    return 10;
                }
                return LEFT + ASCENSION;
            }
        }

        public int AdjustedRight
        {
            get
            {
                if ((RIGHT + ASCENSION) > 10)
                {
                    return 10;
                }
                return RIGHT + ASCENSION;
            }
        }

        public int AdjustedBottom
        {
            get
            {
                if ((BOTTOM + ASCENSION) > 10)
                {
                    return 10;
                }
                return BOTTOM + ASCENSION;
            }
        }

        public bool IsMine
        {
            get { return HAVECARD == 1 && OWNER == 1; }
        }

        public bool IsOpponents
        {
            get { return HAVECARD == 1 && OWNER == 2; }
        }

        public string ToString()
        {
            //return "unk_0: " + unk_0 + ", unk_4: " + unk_4 + ", unk_8: " + unk_8 + ", unk_C: " + unk_C +
            //       ", unk_10: " + unk_10 + ", unk_14: " + unk_14 + ", unk_18: " + unk_18 + ", unk_1C: " + unk_1C +
            //       ", unk_20: " + unk_20 + ", unk_24: " + unk_24 + ", unk_28: " + unk_28 + ", unk_2C: " + unk_2C +
            //       ", unk_30: " + unk_30 + ", unk_34: " + unk_34 + ", unk_38: " + unk_38 + ", unk_3C: " + unk_3C +
            //       ", Stars: " + STARS + ", unk_41: " + unk_41 + ", Owner: " + OWNER + ", Top: " + TOP +
            //       ", Bottom: " + BOTTOM + ", Left: " + LEFT + ", Right: " + RIGHT + ", unk_47: " + unk_47 +
            //       ", unk_48: " + unk_48 + ", unk_49: " + unk_49 + ", unk_4A: " + unk_4A + ", unk_4B: " + unk_4B +
            //       ", unk_4C: " + unk_4C + ", unk_50: " + unk_50 + ", unk_51: " + unk_51 + ", unk_52: " + unk_52 +
            //       ", unk_53: " + unk_53 + ", Ascension: " + ASCENSION + ", unk_55: " + unk_55 + ", unk_56: " + unk_56 +
            //       ", unk_57: " + unk_57 + ", unk_58: " + unk_58 + ", unk_59: " + unk_59 + ", unk_5A: " + unk_5A +
            //       ", unk_5B: " + unk_5B + ", Have Card: " + HAVECARD + ", unk_5D: " + unk_5D + ", unk_5E: " + unk_5E +
            //       ", unk_5F: " + unk_5F;

            //var retstring = "";
            //foreach(var prop in this.GetType().GetProperties()){
            //retstring = retstring + prop.Name + ": " + prop.GetValue(this, null) + ", ";
            //}

            //foreach(var field in this.GetType().GetFields()){
            // retstring = retstring + field.Name + ": " + field.GetValue(this) + ", ";
            //}
            //return retstring;

            return JsonConvert.SerializeObject(this);
        }
    }

#else



    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct Card
    {
        //public uint unk_0;
        private byte unk_0;
        private byte unk_1;
        private byte unk_2;
        private byte unk_3;
        //public uint unk_4;
        private byte unk_4;
        private byte unk_5;
        private byte unk_6;
        private byte unk_7;
        //public uint unk_8;
        private byte unk_8;
        private byte unk_9;
        private byte unk_A;
        private byte unk_B;
        //public uint unk_C;
        private byte unk_C;
        private byte unk_D;
        private byte unk_E;
        private byte unk_F;
        //public uint unk_10;
        private byte unk_10;
        private byte unk_11;
        private byte unk_12;
        private byte unk_13;
        //public uint unk_14;
        private byte unk_14;
        private byte unk_15;
        private byte unk_16;
        private byte unk_17;
        //public uint unk_18;
        private byte unk_18;
        private byte unk_19;
        private byte unk_1A;
        private byte unk_1B;
        //public uint unk_1C;
        private byte unk_1C;
        private byte unk_1D;
        private byte unk_1E;
        private byte unk_1F;
        //public uint unk_20;
        private byte unk_20;
        private byte unk_21;
        private byte unk_22;
        private byte unk_23;
        //public uint unk_24;
        private byte unk_24;
        private byte unk_25;
        private byte unk_26;
        private byte unk_27;
        //public uint unk_28;
        private byte unk_28;
        private byte unk_29;
        private byte unk_2A;
        private byte unk_2B;
        //public uint unk_2C;
        private byte unk_2C;
        private byte unk_2D;
        private byte unk_2E;
        private byte unk_2F;
        //public uint unk_30;
        private byte unk_30;
        private byte unk_31;
        private byte unk_32;
        private byte unk_33;
        //public uint unk_34;
        private byte unk_34;
        private byte unk_35;
        private byte unk_36;
        private byte unk_37;
        //public uint unk_38;
        private byte unk_38;
        private byte unk_39;
        private byte unk_3A;
        private byte unk_3B;
        //public uint unk_3C;
        private byte unk_3C;
        private byte unk_3D;
        private byte unk_3E;
        private byte unk_3F;
        public byte STARS;
        private byte unk_41;
        public byte OWNER;
        public byte TOP;
        public byte BOTTOM;
        public byte LEFT;
        public byte RIGHT;
        private byte unk_47;
        //public uint unk_48;
        private byte unk_48;
        private byte unk_49;
        private byte unk_4A;
        private byte unk_4B;
        //public uint unk_4C;
        private byte unk_4C;
        private byte unk_4D;
        private byte unk_4E;
        private byte unk_4F;
        //public uint unk_50;
        private byte unk_50;
        private byte unk_51;
        private byte unk_52;
        private byte unk_53;
        public sbyte ASCENSION;
        private byte unk_55;
        private byte unk_56;
        private byte unk_57;
        //public uint unk_58;
        private byte unk_58;
        private byte unk_59;
        private byte unk_5A;
        private byte unk_5B;
        public byte HAVECARD;
        private byte unk_5D;
        private byte unk_5E;
        private byte unk_5F;

        public int this[string var]
        {
            get
            {
                switch (var)
                {
                    case "TOP":
                        return TOP;
                    case "BOTTOM":
                        return BOTTOM;
                    case "LEFT":
                        return LEFT;
                    case "RIGHT":
                        return RIGHT;
                    default:
                        return HAVECARD;
                }
            }
        }

        public int AdjustedTop
        {
            get
            {
                if ((TOP + ASCENSION) > 10)
                {
                    return 10;
                }
                return TOP + ASCENSION;
            }
        }

        public int AdjustedLeft
        {
            get
            {
                if ((LEFT + ASCENSION) > 10)
                {
                    return 10;
                }
                return LEFT + ASCENSION;
            }
        }

        public int AdjustedRight
        {
            get
            {
                if ((RIGHT + ASCENSION) > 10)
                {
                    return 10;
                }
                return RIGHT + ASCENSION;
            }
        }

        public int AdjustedBottom
        {
            get
            {
                if ((BOTTOM + ASCENSION) > 10)
                {
                    return 10;
                }
                return BOTTOM + ASCENSION;
            }
        }

        public bool IsMine
        {
            get { return HAVECARD == 1 && OWNER == 1; }
        }

        public bool IsOpponents
        {
            get { return HAVECARD == 1 && OWNER == 2; }
        }

        public string ToString()
        {
            //return "unk_0: " + unk_0 + ", unk_4: " + unk_4 + ", unk_8: " + unk_8 + ", unk_C: " + unk_C +
            //       ", unk_10: " + unk_10 + ", unk_14: " + unk_14 + ", unk_18: " + unk_18 + ", unk_1C: " + unk_1C +
            //       ", unk_20: " + unk_20 + ", unk_24: " + unk_24 + ", unk_28: " + unk_28 + ", unk_2C: " + unk_2C +
            //       ", unk_30: " + unk_30 + ", unk_34: " + unk_34 + ", unk_38: " + unk_38 + ", unk_3C: " + unk_3C +
            //       ", Stars: " + STARS + ", unk_41: " + unk_41 + ", Owner: " + OWNER + ", Top: " + TOP +
            //       ", Bottom: " + BOTTOM + ", Left: " + LEFT + ", Right: " + RIGHT + ", unk_47: " + unk_47 +
            //       ", unk_48: " + unk_48 + ", unk_49: " + unk_49 + ", unk_4A: " + unk_4A + ", unk_4B: " + unk_4B +
            //       ", unk_4C: " + unk_4C + ", unk_50: " + unk_50 + ", unk_51: " + unk_51 + ", unk_52: " + unk_52 +
            //       ", unk_53: " + unk_53 + ", Ascension: " + ASCENSION + ", unk_55: " + unk_55 + ", unk_56: " + unk_56 +
            //       ", unk_57: " + unk_57 + ", unk_58: " + unk_58 + ", unk_59: " + unk_59 + ", unk_5A: " + unk_5A +
            //       ", unk_5B: " + unk_5B + ", Have Card: " + HAVECARD + ", unk_5D: " + unk_5D + ", unk_5E: " + unk_5E +
            //       ", unk_5F: " + unk_5F;

            //var retstring = "";
            //foreach(var prop in this.GetType().GetProperties()){
            //retstring = retstring + prop.Name + ": " + prop.GetValue(this, null) + ", ";
            //}

            //foreach(var field in this.GetType().GetFields()){
            // retstring = retstring + field.Name + ": " + field.GetValue(this) + ", ";
            //}
            //return retstring;

            return JsonConvert.SerializeObject(this);
        }
    }




#endif
}
