﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Resources;
using System.Text;
using System.Threading.Tasks;
using ff14bot.Helpers;

namespace TripleTriHard.Localization
{
    /// <summary>
    /// This jiggery is required due to how hb/rb/etc handle the resource system.
    /// </summary>
    public static class LocalizationInitializer
    {

        internal static bool Initialized = false;

        private static void AddLocalizedResourcesFromAssembly(ResourceManager resourceMgr)
        {
            AddLocalizedResource(resourceMgr, "zh-CN");
        }

        private static void AddLocalizedResource(ResourceManager resourceMgr, string cultureName)
        {
            using (Stream s = Assembly.GetExecutingAssembly().GetManifestResourceStream("TripleTriHard.Localization.Localization." + cultureName + ".resources"))
            {
                if (s == null)
                {
                    Logging.WriteDiagnostic("Couldn't find {0}", "TripleTriHard.Localization.Localization." + cultureName + ".resources");
                    return;
                }

                FieldInfo resourceSetsField = typeof(ResourceManager).GetField("_resourceSets", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetField);
                Dictionary<string, ResourceSet> resourceSets = (Dictionary<string, ResourceSet>)resourceSetsField.GetValue(resourceMgr);

                ResourceSet resources = new ResourceSet(s);
                resourceSets.Add(cultureName, resources);
                Initialized = true;
            }
        }

        public static void Initalize()
        {
            if (!Initialized)
            {
                AddLocalizedResourcesFromAssembly(Localization.ResourceManager);
            }
        }
    }
}
