﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TripleTriHard
{
    public class Move
    {
        public int SlotNumber { get; set; }
        public uint CardIndex { get; set; }

        public int Captures { get; set; }
        public int Blocked { get; set; }
        public int Exposed { get; set; }

        public int LeftExposedValue { get; set; }
        public int RightExposedValue { get; set; }
        public int TopExposedValue { get; set; }
        public int BottomExposedValue { get; set; }

        public bool IsMoveValid { get; set; }

        public Move(int slot, uint card, int cap, int block, int exp, int top = 0, int bottom = 0, int left = 0, int right = 0)
        {
            SlotNumber = slot;
            CardIndex = card;
            Captures = cap;
            Blocked = block;
            Exposed = exp;
            IsMoveValid = true;
            TopExposedValue = top;
            BottomExposedValue = bottom;
            LeftExposedValue = left;
            RightExposedValue = right;
        }
    }
}
