﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;
using System.Threading.Tasks;
using System.Windows.Media;
using Clio.Utilities;
using ff14bot;
using ff14bot.AClasses;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using ff14bot.Pathing.Service_Navigation;
using ff14bot.RemoteAgents;
using ff14bot.RemoteWindows;
using GreyMagic;
using TreeSharp;
using Action = TreeSharp.Action;

namespace TripleTriHard
{
    public class TripleTriHard : BotBase
    {

        static TripleTriHard()
        {
            Localization.LocalizationInitializer.Initalize();
        }


        public Composite _root;
        public TripleTriHardForm _settings;
        public static TripleTriHardSettings Settings = TripleTriHardSettings.Instance;
        public bool NeedToUpdate = true;
        public bool NeedToGetRules = true;

        public static Timer timer = new Timer(1000);

        public static int StartMGP = 0;

        public static DateTime StartTime;

        public static double MgpPerHour;

        public static List<Card> MyCards = new List<Card>();
        public static List<Card> TheirCards = new List<Card>();
        public static List<BoardSlot> Board = new List<BoardSlot>();
        public static List<string> Rules = new List<string>();
        public static List<TripleTriadNPC> TripleTriadNPCs = new List<TripleTriadNPC>
        {
            new TripleTriadNPC("Yayake", 1002279, 130, "-196.8872, 18.46, 59.95264", 9, 20),
            new TripleTriadNPC("Rowena", 1001304, 156, "25.58936, 29, -825.3757", 0, 0),
            new TripleTriadNPC("Tataru", 1012858, 433, "-0.8087769, 0.02225424, 4.53186", 19, 7),
            new TripleTriadNPC("Idle Imperial", 1015021, 402, "280.0183, 30.92421, 436.7896", 21, 8),
            new TripleTriadNPC("Gibrillont", 1011192, 418, "88.36499, 15.09468, 31.29626", 2, 10),
            new TripleTriadNPC("Noes", 1000282, 133, "-31.81512, 9.658875, -287.068", 10, 20),
            new TripleTriadNPC("Yellow Moon", 1001691, 131, "142.1682, 7.492003, 104.7227", 22, 6),
            new TripleTriadNPC("Wawalago", 1000856, 129, "-155.108, 4.070978, 202.7161", 15, 3),
            new TripleTriadNPC("Marielle", 1012060, 401, "-358.6633, -157.9937, 761.0131", 2, 10),
            new TripleTriadNPC("Marcechamp", 1011916, 398, "470.0236, -49.89133, 20.37079", 19, 5),
            new TripleTriadNPC("Trachtoum", 1006264, 135, "710.9025, 66.027, -277.6685", 20, 8),
            new TripleTriadNPC("Helmhart", 1006209, 145, "-67.27704, -20.29624, -3.006042", 10, 20),
            new TripleTriadNPC("Piralnaut", 1006189, 152, "-201.0377, 20.21284, 254.261", 12, 20),
            new TripleTriadNPC("Swift", 1004576, 130, "-141.6495, 4.1, -114.6716", 6, 11),
            new TripleTriadNPC("Vorsaile Heuloix", 1000168, 132, "-75.48645, -0.5013741, -5.081299", 22, 3),
            new TripleTriadNPC("Baderon", 1000972, 128, "20.27917, 40.19993, -6.118958", 0, 0),
            new TripleTriadNPC("R'ashaht Rhiki", 1003281, 128, "97.52039, 40.24854, 81.1322", 14, 19),
            new TripleTriadNPC("Marcette", 1006261, 148, "-244.7394, 58.69352, -140.0626", 16, 8),
            new TripleTriadNPC("Fufulupa", 1002058, 140, "59.61694, 45.20513, -215.9", 0, 0)
        };

        public List<Tuple<Tuple<int, string>, Tuple<int, string>>> Connections = new List<Tuple<Tuple<int, string>, Tuple<int, string>>>();



        public override string Name
        {
            get { return Localization.Localization.Botbase_Name; }
        }

        public override string EnglishName
        {
            get { return "TripleTriHard"; }
        }

        public override bool IsAutonomous
        {
            get { return true; }
        }

        public bool Debug = false;

        public static Version Version = new Version(1, 1, 1);

        public override void OnButtonPress()
        {
            if (_settings == null || _settings.IsDisposed)
                _settings = new TripleTriHardForm();
            try
            {
                _settings.Show();
                _settings.Activate();
            }
            catch (ArgumentOutOfRangeException ee)
            {
            }
        }

        public override void Initialize()
        {
            base.Initialize();
        }

        public override void Start()
        {
            Navigator.PlayerMover = new SlideMover();
            Navigator.NavigationProvider = new ServiceNavigationProvider();

            // Setup
            CreateBoard();

            // Clear out old cards
            MyCards.Clear();
            TheirCards.Clear();

            // Start Timer
            timer.Start();

            // Set Start Time
            StartTime = DateTime.Now;

            // Hook Timer Event
            timer.Elapsed += CalculateMGP;

            // Get starting MGP
            var startmgp = InventoryManager.GetBagByInventoryBagId(InventoryBagId.Currency).FilledSlots.FirstOrDefault(r => r.RawItemId == 29);
            if (startmgp != null)
                StartMGP = (int)startmgp.Count;

            NeedToGetRules = true;

            foreach (var slot in Board)
            {
                slot.IsCardValid = false;
            }

            LogMessage("Starting TripleTriHard");
        }

        public override void Stop()
        {
            var gaiaNavigator = Navigator.NavigationProvider as IDisposable;
            if (gaiaNavigator != null)
                gaiaNavigator.Dispose();

            // Clear out old cards
            MyCards.Clear();
            TheirCards.Clear();
            Board.Clear();

            // End Timer
            timer.Stop();

            // Clear Start Time
            StartTime = new DateTime();

            // Unhook Timer Event
            timer.Elapsed -= CalculateMGP;

            // Clear MGP
            StartMGP = 0;
            MgpPerHour = 0;

            NeedToGetRules = true;

            LogMessage("Stopping TripleTriHard");
        }

        private static void CalculateMGP(Object source, System.Timers.ElapsedEventArgs e)
        {
            var mgp = InventoryManager.GetBagByInventoryBagId(InventoryBagId.Currency).FilledSlots.FirstOrDefault(r => r.RawItemId == 29);
            if (mgp != null)
            {
                var minutes = (DateTime.Now - StartTime).TotalMinutes;
                MgpPerHour = (60 / minutes) * (mgp.Count - StartMGP);
            }
        }

        public static TimeSpan TimeSinceStart
        {
            get
            {
                if (TreeRoot.IsRunning)
                    return DateTime.Now - StartTime;
                return TimeSpan.Zero;
            }
        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        public override bool RequiresProfile
        {
            get { return false; }
        }


        public override bool WantButton
        {
            get { return true; }
        }


        private void LogMessage(string text, params object[] list)
        {
            Logging.Write(Colors.Aqua, "[TripleTriHard v" + Version + "] " + text, list);
        }
        private void LogMessage(string text)
        {
            Logging.Write(Colors.Aqua, "[TripleTriHard v" + Version + "] " + text);
        }
        private void LogComboMessage(string text)
        {
            Logging.Write(Colors.LightSeaGreen, "[TripleTriHard v" + Version + "] " + text);
        }

        private void LogDebug(string text)
        {
            Logging.Write(Colors.Red, text);
        }

        public void UpdateCards()
        {
            if (!TripleTriad.IsOpen)
                return;

            LogMessage("Updating board...");
            // Clear out old cards
            MyCards.Clear();
            TheirCards.Clear();
            foreach (var slot in Board)
            {
                slot.IsCardValid = false;
            }

            var cardcount = 0;
            var cellcount = 0;
            var activeCards = TripleTriad.Cards<Card>();

            var myCards = new Card[5];
            var theirCards = new Card[5];
            var inPlayCards = new Card[9];

            Array.Copy(activeCards, 0, myCards, 0, 5);
            Array.Copy(activeCards, 5, theirCards, 0, 5);
            Array.Copy(activeCards, 10, inPlayCards, 0, 9);

            MyCards.AddRange(myCards);
            TheirCards.AddRange(theirCards);

            foreach (var card in inPlayCards)
            {
                GetBoardSlot(cellcount).Card = card;
                GetBoardSlot(cellcount).IsCardValid = true;
                cellcount++;
            }


            if (Debug)
            {
                foreach (var card in myCards)
                {
                    LogMessage("My Card " + cardcount + " | " + card.ToString());
                    cardcount++;
                }
                foreach (var card in theirCards)
                {
                    LogMessage("Their Card " + (cardcount - 5) + " | Top: " + card.TOP + ", Bottom: " + card.BOTTOM + ", Left: " + card.LEFT + ", Right: " + card.RIGHT + ", Has Card: " + card.HAVECARD + ", Stars: " + card.STARS + ", Owner: " + card.OWNER + ", Ascension: " + card.ASCENSION);
                    cardcount++;
                }
                foreach (var card in inPlayCards)
                {
                    LogMessage("Board Card " + cellcount + " | Top: " + card.TOP + ", Bottom: " + card.BOTTOM + ", Left: " + card.LEFT + ", Right: " + card.RIGHT + ", Has Card: " + card.HAVECARD + ", Stars: " + card.STARS + ", Owner: " + card.OWNER + ", Ascension: " + card.ASCENSION);
                    cellcount++;
                }

            }

        }

        public void UpdateRules()
        {
            var i = 0;
            foreach (var rule in AgentTripleTriad.Instance.ActiveRules)
            {
                LogMessage("Rule " + i + ": " + rule);
                i++;
            }
            NeedToGetRules = false;
        }

        public void ClearRules()
        {
            NeedToGetRules = true;
        }

        public int NumOfMyCards
        {
            get { return MyCards.Count(r => r.HAVECARD == 1); }
        }

        public int NumOfOpponentCards
        {
            get { return TheirCards.Count(r => r.HAVECARD == 1); }
        }

        public bool IsSlotOpen(int slot)
        {
            return Board.FirstOrDefault(r => r.SlotNumber == slot).IsOpen();
        }

        public bool HaveSpecificCard(int top, int bottom, int left, int right)
        {
            return MyCards.Count(r => r.TOP == top && r.BOTTOM == bottom && r.LEFT == left && r.RIGHT == right) > 0;
        }

        public uint GetIndexOfMyCard(int top, int bottom, int left, int right)
        {
            return (uint)MyCards.FindIndex(r => r.TOP == top && r.BOTTOM == bottom && r.LEFT == left && r.RIGHT == right);
        }

        public uint GetIndexOfMyCard(Card card)
        {
            return (uint)MyCards.FindIndex(r => r.TOP == card.TOP && r.BOTTOM == card.BOTTOM && r.LEFT == card.LEFT && r.RIGHT == card.RIGHT);
        }

        public Card GetMyCardByIndex(uint index)
        {
            return MyCards[(int)index];
        }

        public BoardSlot GetBoardSlot(int slot)
        {
            return Board.FirstOrDefault(r => r.SlotNumber == slot);
        }

        public bool NotNPCTime
        {
            get
            {
                var npc = TripleTriadNPCs.FirstOrDefault(o => o.NpcId == Settings.NpcId);
                if (npc != null && npc.EndTime < npc.StartTime && npc.StartTime > 0 && npc.EndTime > 0)
                {
                    return !ConditionParser.IsTimeBetween(npc.StartTime, 24) &&
                           !ConditionParser.IsTimeBetween(0, npc.EndTime);
                }
                if (npc != null && npc.StartTime > 0 && npc.EndTime > 0)
                {
                    return !ConditionParser.IsTimeBetween(npc.StartTime, npc.EndTime);
                }
                return false;
            }
        }

        public bool HasRule(TripleTriadRule rule)
        {
            var activeRules = AgentTripleTriad.Instance.ActiveRules;
            return activeRules.Contains(rule);
        }

        public void CreateBoard()
        {
            LogMessage("Creating Board...");
            // Initialize Slots
            BoardSlot slot0 = new BoardSlot(0);
            BoardSlot slot1 = new BoardSlot(1);
            BoardSlot slot2 = new BoardSlot(2);
            BoardSlot slot3 = new BoardSlot(3);
            BoardSlot slot4 = new BoardSlot(4);
            BoardSlot slot5 = new BoardSlot(5);
            BoardSlot slot6 = new BoardSlot(6);
            BoardSlot slot7 = new BoardSlot(7);
            BoardSlot slot8 = new BoardSlot(8);
            // Slot 0
            slot0.BottomConnection = slot3;
            slot0.RightConnection = slot1;
            // Slot 1
            slot1.LeftConnection = slot0;
            slot1.BottomConnection = slot4;
            slot1.RightConnection = slot2;
            // Slot 2
            slot2.LeftConnection = slot1;
            slot2.BottomConnection = slot5;
            // Slot 3
            slot3.TopConnection = slot0;
            slot3.RightConnection = slot4;
            slot3.BottomConnection = slot6;
            // Slot 4
            slot4.TopConnection = slot1;
            slot4.LeftConnection = slot3;
            slot4.RightConnection = slot5;
            slot4.BottomConnection = slot7;
            // Slot 5
            slot5.TopConnection = slot2;
            slot5.LeftConnection = slot4;
            slot5.BottomConnection = slot8;
            // Slot 6
            slot6.TopConnection = slot3;
            slot6.RightConnection = slot7;
            // Slot 7
            slot7.TopConnection = slot4;
            slot7.LeftConnection = slot6;
            slot7.RightConnection = slot8;
            // Slot 8
            slot8.TopConnection = slot5;
            slot8.LeftConnection = slot7;
            // Add them all to the board!
            Board.Add(slot0);
            Board.Add(slot1);
            Board.Add(slot2);
            Board.Add(slot3);
            Board.Add(slot4);
            Board.Add(slot5);
            Board.Add(slot6);
            Board.Add(slot7);
            Board.Add(slot8);
            //foreach (var slot in Board)
            //{
            //    LogMessage("" + slot);
            //}
            LogMessage("Board Created Successfully!");
        }

        // card #, slot #
        public void MakeBestMove()
        {
            #region Validity Checks/Initialization
            // Make sure the TT window is still open
            if (!TripleTriad.IsOpen)
            {
                return;
            }

            // Initialize list of possible moves
            List<Move> PossibleMoves = new List<Move>();
            #endregion

            #region King Elmer Strategy
            // Custom King Elmer Strategy
            // Deck: Dodo, Sabotender, Coeurl, Ixal, and a fifth card (Godbert maybe?)
            if (Core.Player.HasTarget && Core.Target.NpcId == 1011055)
            {
                // If this is our first play
                if (NumOfMyCards == 5)
                {
                    // Make sure slot 8 is open and we have the Dodo card to play there
                    if (IsSlotOpen(8) && HaveSpecificCard(4, 3, 4, 2))
                    {
                        LogMessage("Playing Dodo in slot 8!");
                        TripleTriad.PlayCard(GetIndexOfMyCard(4, 3, 4, 2), 8);
                        return;
                    }
                    goto Normal;
                }
                // If this is our second play
                if (NumOfMyCards == 4)
                {
                    // Play Coeurl in slot 1 if slot 5 has been taken
                    if (!IsSlotOpen(5) && IsSlotOpen(1) && HaveSpecificCard(2, 2, 5, 5))
                    {
                        LogMessage("Playing Dodo in slot 8!");
                        TripleTriad.PlayCard(GetIndexOfMyCard(2, 2, 5, 5), 1);
                        return;
                    }
                    goto Normal;
                }
                // If this is our third play
                if (NumOfMyCards == 3)
                {
                    // Play Sabotender in slot 0, slot 6, slot 7, or slot 3 (in that order of preference)
                    if ((IsSlotOpen(0) || IsSlotOpen(6) || IsSlotOpen(7) || IsSlotOpen(3)) && HaveSpecificCard(4, 3, 3, 3))
                    {
                        if (IsSlotOpen(0))
                        {
                            LogMessage("Playing Sabotender in slot 0!");
                            TripleTriad.PlayCard(GetIndexOfMyCard(4, 3, 3, 3), 0);
                            return;
                        }
                        if (IsSlotOpen(6))
                        {
                            LogMessage("Playing Sabotender in slot 6!");
                            TripleTriad.PlayCard(GetIndexOfMyCard(4, 3, 3, 3), 6);
                            return;
                        }
                        if (IsSlotOpen(7))
                        {
                            LogMessage("Playing Sabotender in slot 7!");
                            TripleTriad.PlayCard(GetIndexOfMyCard(4, 3, 3, 3), 7);
                            return;
                        }
                        if (IsSlotOpen(3))
                        {
                            LogMessage("Playing Sabotender in slot 3!");
                            TripleTriad.PlayCard(GetIndexOfMyCard(4, 3, 3, 3), 3);
                            return;
                        }
                    }
                    goto Normal;
                }
                // If this is our fourth play
                if (NumOfMyCards == 2)
                {
                    // Play Ixal in slot 2 if slot 5 and 1 are filled
                    if (!IsSlotOpen(5) && !IsSlotOpen(1) && IsSlotOpen(2) && HaveSpecificCard(6, 3, 4, 1))
                    {
                        LogMessage("Playing Ixal in slot 2!");
                        TripleTriad.PlayCard(GetIndexOfMyCard(6, 3, 4, 1), 2);
                        return;
                    }
                    goto Normal;
                }
                // For the last play, just let the normal strategy take over
            }
            #endregion

            #region Indolent Imperial Strategy (Scion Deck)
            // Custom Indolent Imperial Strategy
            // Deck: Y'shtola, Papalymo & Yda, Thancred, Urianger, Minfilia
            if (Core.Player.HasTarget && Core.Target.NpcId == 1011789)
            {
                // If we are going first, make a strategy
                if (NumOfMyCards == 5 && Board.Count(r => r.IsOpen()) == 9)
                {
                    // Make sure slot 3 is open and we have Y'shtola to play there
                    if (IsSlotOpen(3) && HaveSpecificCard(7, 1, 4, 8))
                    {
                        LogMessage("Playing Y'shtola in slot 4!");
                        TripleTriad.PlayCard(GetIndexOfMyCard(7, 1, 4, 8), 3);
                        return;
                    }
                }

                // If I have the same number of cards as my opponent, I went first
                // Only execute the other steps of this strategy if I went first
                if (NumOfMyCards == NumOfOpponentCards)
                {
                    if (NumOfMyCards == 4)
                    {
                        // If Y'shtola is played in slot 3 and has been taken by the opponent, use Papalymo & Yda in slot 0 to take her back
                        if (IsSlotOpen(0) && HaveSpecificCard(3, 8, 2, 7) && (!IsSlotOpen(3) && GetBoardSlot(3).Card.IsOpponents))
                        {
                            LogMessage("Playing Papalymo & Yda in slot 1!");
                            TripleTriad.PlayCard(GetIndexOfMyCard(3, 8, 2, 7), 0);
                            return;
                        }

                        // If Y'shtola is played in slot 3 and has been taken by the opponent, use Papalymo & Yda in slot 0 to take her back
                        if (IsSlotOpen(6) && HaveSpecificCard(3, 8, 2, 7) && (!IsSlotOpen(3) && GetBoardSlot(3).Card.IsOpponents))
                        {
                            LogMessage("Playing Papalymo & Yda in slot 7!");
                            TripleTriad.PlayCard(GetIndexOfMyCard(3, 8, 2, 7), 6);
                            return;
                        }
                    }
                }
            }
            #endregion

            #region Indolent Imperial Strategy
            // Custom Indolent Imperial Strategy
            // Deck: Amalj'aa, Frixio, Mutamix, Scarface Bugaal Ja, Memeroon
            if (Core.Player.HasTarget && Core.Target.NpcId == 1011789)
            {
                if (NumOfMyCards == 5)
                {
                    // Make sure slot 8 is open and we have the Amalj'aa card to play there
                    if (IsSlotOpen(8) && HaveSpecificCard(1, 7, 1, 4))
                    {
                        LogMessage("Playing Amalj'aa in slot 9!");
                        TripleTriad.PlayCard(GetIndexOfMyCard(1, 7, 1, 4), 8);
                        return;
                    }
                    goto Normal;
                }
            }
            #endregion

            #region Check Rules

            if (HasRule(TripleTriadRule.Reverse))
            {
                goto Reverse;
            }
            else
            {
                goto Normal;
            }

            #endregion

            #region Reverse Strategy
            // Implement a strategy for the reverse ruleset
            Reverse:
            // Check each of my playable cards
            foreach (var mycard in MyCards.Where(r => r.HAVECARD == 1))
            {
                // Check against each open board slot
                foreach (var boardslot in Board.Where(r => r.IsOpen()))
                {
                    var captures = 0;
                    var blocked = 0;
                    var exposed = 0;
                    var topexposed = 0;
                    var bottomexposed = 0;
                    var leftexposed = 0;
                    var rightexposed = 0;

                    #region Plus Rule
                    // Check for Plus rule
                    if (HasRule(TripleTriadRule.Plus))
                    {
                        List<Tuple<BoardSlot, int>> PlusValues = new List<Tuple<BoardSlot, int>>();
                        int TopValue;
                        int LeftValue;
                        int RightValue;
                        int BottomValue;
                        // Check value of connections
                        if (boardslot.TopConnection != null)
                        {
                            var competingcard = boardslot.TopConnection.Card;
                            TopValue = mycard.AdjustedTop + competingcard.AdjustedBottom;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.TopConnection, TopValue));
                        }
                        if (boardslot.LeftConnection != null)
                        {
                            var competingcard = boardslot.LeftConnection.Card;
                            LeftValue = mycard.AdjustedLeft + competingcard.AdjustedRight;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.LeftConnection, LeftValue));
                        }
                        if (boardslot.RightConnection != null)
                        {
                            var competingcard = boardslot.RightConnection.Card;
                            RightValue = mycard.AdjustedRight + competingcard.AdjustedLeft;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.RightConnection, RightValue));
                        }
                        if (boardslot.BottomConnection != null)
                        {
                            var competingcard = boardslot.BottomConnection.Card;
                            BottomValue = mycard.AdjustedBottom + competingcard.AdjustedTop;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.BottomConnection, BottomValue));
                        }
                        // Find items where there's more than one side with a certain added value
                        var Matches = PlusValues.GroupBy(o => o.Item2).Where(o => o.Count() > 1);

                        List<BoardSlot> VisitedSlots = new List<BoardSlot>();
                        Stack<BoardSlot> SlotsToCombo = new Stack<BoardSlot>();
                        // If we have a match, time to do logic
                        if (Matches.Count() > 1)
                        {
                            // There might be two groups
                            foreach (var group in Matches)
                            {
                                // Get each matching side
                                foreach (var match in group)
                                {
                                    // The Combo rule only applies if the card belongs to the opponent
                                    if (match.Item1.Card.IsOpponents)
                                    {
                                        // First off, count the capture that we get for this card
                                        captures++;

                                        // Next, add this boardslot to the ToVisit stack
                                        SlotsToCombo.Push(match.Item1);

                                        // Also add this to the VisitedSlots list so we don't come back to it
                                        VisitedSlots.Add(match.Item1);

                                        LogComboMessage("Slot " + match.Item1.SlotNumber + " will combo!");
                                    }
                                }
                            }
                            // Check all our combo possibilities
                            while (SlotsToCombo.Count >= 1)
                            {
                                var SlotToCheck = SlotsToCombo.Pop();
                                // Check for a combo on the top
                                if (SlotToCheck.TopConnection != null && !VisitedSlots.Contains(SlotToCheck.TopConnection))
                                {
                                    var combocheck = SlotToCheck.TopConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedTop < combocheck.AdjustedBottom)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.TopConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.TopConnection);

                                        LogComboMessage("Slot " + SlotToCheck.TopConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the left
                                if (SlotToCheck.LeftConnection != null && !VisitedSlots.Contains(SlotToCheck.LeftConnection))
                                {
                                    var combocheck = SlotToCheck.LeftConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedLeft < combocheck.AdjustedRight)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.LeftConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.LeftConnection);

                                        LogComboMessage("Slot " + SlotToCheck.LeftConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the right
                                if (SlotToCheck.RightConnection != null && !VisitedSlots.Contains(SlotToCheck.RightConnection))
                                {
                                    var combocheck = SlotToCheck.RightConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedRight < combocheck.AdjustedLeft)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.RightConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.RightConnection);

                                        LogComboMessage("Slot " + SlotToCheck.RightConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the bottom
                                if (SlotToCheck.BottomConnection != null && !VisitedSlots.Contains(SlotToCheck.BottomConnection))
                                {
                                    var combocheck = SlotToCheck.BottomConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedBottom < combocheck.AdjustedTop)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.BottomConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.BottomConnection);

                                        LogComboMessage("Slot " + SlotToCheck.BottomConnection.SlotNumber + " will combo!");
                                    }
                                }
                            }
                        }
                    }
                    #endregion

                    #region Same Rule
                    // Check for Same rule
                    if (HasRule(TripleTriadRule.Same))
                    {
                        List<BoardSlot> SameValues = new List<BoardSlot>();
                        // Check if connections are equal
                        if (boardslot.TopConnection != null)
                        {
                            var competingcard = boardslot.TopConnection.Card;
                            if (mycard.AdjustedTop == competingcard.AdjustedBottom)
                            {
                                SameValues.Add(boardslot.TopConnection);
                            }
                        }
                        if (boardslot.LeftConnection != null)
                        {
                            var competingcard = boardslot.LeftConnection.Card;
                            if (mycard.AdjustedLeft == competingcard.AdjustedRight)
                            {
                                SameValues.Add(boardslot.LeftConnection);
                            }
                        }
                        if (boardslot.RightConnection != null)
                        {
                            var competingcard = boardslot.RightConnection.Card;
                            if (mycard.AdjustedRight == competingcard.AdjustedLeft)
                            {
                                SameValues.Add(boardslot.RightConnection);
                            }
                        }
                        if (boardslot.BottomConnection != null)
                        {
                            var competingcard = boardslot.BottomConnection.Card;
                            if (mycard.AdjustedBottom == competingcard.AdjustedTop)
                            {
                                SameValues.Add(boardslot.BottomConnection);
                            }
                        }

                        List<BoardSlot> VisitedSlots = new List<BoardSlot>();
                        Stack<BoardSlot> SlotsToCombo = new Stack<BoardSlot>();
                        // If we have a match, time to do logic
                        if (SameValues.Count() > 1)
                        {
                            // Get each matching side
                            foreach (var match in SameValues)
                            {
                                // The Combo rule only applies if the card belongs to the opponent
                                if (match.Card.IsOpponents)
                                {
                                    // First off, count the capture that we get for this card
                                    captures++;

                                    // Next, add this boardslot to the ToVisit stack
                                    SlotsToCombo.Push(match);

                                    // Also add this to the VisitedSlots list so we don't come back to it
                                    VisitedSlots.Add(match);

                                    LogComboMessage("Slot " + match.SlotNumber + " will combo!");
                                }
                            }
                            // Check all our combo possibilities
                            while (SlotsToCombo.Count >= 1)
                            {
                                var SlotToCheck = SlotsToCombo.Pop();
                                // Check for a combo on the top
                                if (SlotToCheck.TopConnection != null && !VisitedSlots.Contains(SlotToCheck.TopConnection))
                                {
                                    var combocheck = SlotToCheck.TopConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedTop < combocheck.AdjustedBottom)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.TopConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.TopConnection);

                                        LogComboMessage("Slot " + SlotToCheck.TopConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the left
                                if (SlotToCheck.LeftConnection != null && !VisitedSlots.Contains(SlotToCheck.LeftConnection))
                                {
                                    var combocheck = SlotToCheck.LeftConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedLeft < combocheck.AdjustedRight)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.LeftConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.LeftConnection);

                                        LogComboMessage("Slot " + SlotToCheck.LeftConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the right
                                if (SlotToCheck.RightConnection != null && !VisitedSlots.Contains(SlotToCheck.RightConnection))
                                {
                                    var combocheck = SlotToCheck.RightConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedRight < combocheck.AdjustedLeft)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.RightConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.RightConnection);

                                        LogComboMessage("Slot " + SlotToCheck.RightConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the bottom
                                if (SlotToCheck.BottomConnection != null && !VisitedSlots.Contains(SlotToCheck.BottomConnection))
                                {
                                    var combocheck = SlotToCheck.BottomConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedBottom < combocheck.AdjustedTop)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.BottomConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.BottomConnection);

                                        LogComboMessage("Slot " + SlotToCheck.BottomConnection.SlotNumber + " will combo!");
                                    }
                                }
                            }
                        }
                    }
                    #endregion

                    // Check for a capture on the top
                    if (boardslot.TopConnection != null)
                    {
                        var competingcard = boardslot.TopConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedTop < competingcard.AdjustedBottom) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedTop == 10 && competingcard.AdjustedBottom == 1)))
                        {
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            blocked = blocked + competingcard.AdjustedBottom + mycard.AdjustedTop;
                        }
                        if (boardslot.TopConnection.IsOpen())
                        {
                            exposed = exposed + mycard.AdjustedTop;
                            topexposed = mycard.AdjustedTop;
                        }
                    }
                    else
                    {
                        blocked = blocked + mycard.AdjustedTop;
                    }
                    // Check for a capture on the left
                    if (boardslot.LeftConnection != null)
                    {
                        var competingcard = boardslot.LeftConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedLeft < competingcard.AdjustedRight) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedLeft == 10 && competingcard.AdjustedRight == 1)))
                        {
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            blocked = blocked + competingcard.AdjustedRight + mycard.AdjustedLeft;
                        }
                        if (boardslot.LeftConnection.IsOpen())
                        {
                            exposed = exposed + mycard.AdjustedLeft;
                            leftexposed = mycard.AdjustedLeft;
                        }
                    }
                    else
                    {
                        blocked = blocked + mycard.AdjustedLeft;
                    }
                    // Check for a capture on the right
                    if (boardslot.RightConnection != null)
                    {
                        var competingcard = boardslot.RightConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedRight < competingcard.AdjustedLeft) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedRight == 10 && competingcard.AdjustedLeft == 1)))
                        {
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            blocked = blocked + competingcard.AdjustedLeft + mycard.AdjustedRight;
                        }
                        if (boardslot.RightConnection.IsOpen())
                        {
                            exposed = exposed + mycard.AdjustedRight;
                            rightexposed = mycard.AdjustedRight;
                        }
                    }
                    else
                    {
                        blocked = blocked + mycard.AdjustedRight;
                    }
                    // Check for a capture on the bottom
                    if (boardslot.BottomConnection != null)
                    {
                        var competingcard = boardslot.BottomConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedBottom < competingcard.AdjustedTop) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedBottom == 10 && competingcard.AdjustedTop == 1)))
                        {
                            // If the card is the opponent's and my bottom is higher than their top, it's a capture
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            // If the card below is mine, the top of that card and the bottom of my card will be blocked
                            blocked = blocked + competingcard.AdjustedTop + mycard.AdjustedBottom;
                        }
                        if (boardslot.BottomConnection.IsOpen())
                        {
                            // If the bottom is open, that number is free for the taking, so make sure we know it's exposed
                            exposed = exposed + mycard.AdjustedBottom;
                            bottomexposed = mycard.AdjustedBottom;
                        }
                    }
                    else
                    {
                        // If the connection is null, that means there's no slot there so that side is blocked
                        blocked = blocked + mycard.AdjustedBottom;
                    }
                    // Add the move to the list of possible moves
                    PossibleMoves.Add(new Move(boardslot.SlotNumber, GetIndexOfMyCard(mycard), captures, blocked, exposed, topexposed, bottomexposed, leftexposed, rightexposed));
                }
            }
            goto Final;
            #endregion

            #region Normal Strategy
            // Normal strategy takes over from here
            Normal:
            // Check each of my playable cards
            foreach (var mycard in MyCards.Where(r => r.HAVECARD == 1))
            {
                // Check against each open board slot
                foreach (var boardslot in Board.Where(r => r.IsOpen()))
                {
                    var captures = 0;
                    var blocked = 0;
                    var exposed = 0;
                    var topexposed = 0;
                    var bottomexposed = 0;
                    var leftexposed = 0;
                    var rightexposed = 0;

                    #region Plus Rule
                    // Check for Plus rule
                    if (HasRule(TripleTriadRule.Plus))
                    {
                        List<Tuple<BoardSlot, int>> PlusValues = new List<Tuple<BoardSlot, int>>();
                        int TopValue;
                        int LeftValue;
                        int RightValue;
                        int BottomValue;
                        // Check value of connections
                        if (boardslot.TopConnection != null)
                        {
                            var competingcard = boardslot.TopConnection.Card;
                            TopValue = mycard.AdjustedTop + competingcard.AdjustedBottom;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.TopConnection, TopValue));
                        }
                        if (boardslot.LeftConnection != null)
                        {
                            var competingcard = boardslot.LeftConnection.Card;
                            LeftValue = mycard.AdjustedLeft + competingcard.AdjustedRight;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.LeftConnection, LeftValue));
                        }
                        if (boardslot.RightConnection != null)
                        {
                            var competingcard = boardslot.RightConnection.Card;
                            RightValue = mycard.AdjustedRight + competingcard.AdjustedLeft;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.RightConnection, RightValue));
                        }
                        if (boardslot.BottomConnection != null)
                        {
                            var competingcard = boardslot.BottomConnection.Card;
                            BottomValue = mycard.AdjustedBottom + competingcard.AdjustedTop;
                            PlusValues.Add(new Tuple<BoardSlot, int>(boardslot.BottomConnection, BottomValue));
                        }
                        // Find items where there's more than one side with a certain added value
                        var Matches = PlusValues.GroupBy(o => o.Item2).Where(o => o.Count() > 1);

                        List<BoardSlot> VisitedSlots = new List<BoardSlot>();
                        Stack<BoardSlot> SlotsToCombo = new Stack<BoardSlot>();
                        // If we have a match, time to do logic
                        if (Matches.Count() > 1)
                        {
                            // There might be two groups
                            foreach (var group in Matches)
                            {
                                // Get each matching side
                                foreach (var match in group)
                                {
                                    // The Combo rule only applies if the card belongs to the opponent
                                    if (match.Item1.Card.IsOpponents)
                                    {
                                        // First off, count the capture that we get for this card
                                        captures++;

                                        // Next, add this boardslot to the ToVisit stack
                                        SlotsToCombo.Push(match.Item1);

                                        // Also add this to the VisitedSlots list so we don't come back to it
                                        VisitedSlots.Add(match.Item1);

                                        LogComboMessage("Slot " + match.Item1.SlotNumber + " will combo!");
                                    }
                                }
                            }
                            // Check all our combo possibilities
                            while (SlotsToCombo.Count >= 1)
                            {
                                var SlotToCheck = SlotsToCombo.Pop();
                                // Check for a combo on the top
                                if (SlotToCheck.TopConnection != null && !VisitedSlots.Contains(SlotToCheck.TopConnection))
                                {
                                    var combocheck = SlotToCheck.TopConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedTop > combocheck.AdjustedBottom)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.TopConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.TopConnection);

                                        LogComboMessage("Slot " + SlotToCheck.TopConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the left
                                if (SlotToCheck.LeftConnection != null && !VisitedSlots.Contains(SlotToCheck.LeftConnection))
                                {
                                    var combocheck = SlotToCheck.LeftConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedLeft > combocheck.AdjustedRight)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.LeftConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.LeftConnection);

                                        LogComboMessage("Slot " + SlotToCheck.LeftConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the right
                                if (SlotToCheck.RightConnection != null && !VisitedSlots.Contains(SlotToCheck.RightConnection))
                                {
                                    var combocheck = SlotToCheck.RightConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedRight > combocheck.AdjustedLeft)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.RightConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.RightConnection);

                                        LogComboMessage("Slot " + SlotToCheck.RightConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the bottom
                                if (SlotToCheck.BottomConnection != null && !VisitedSlots.Contains(SlotToCheck.BottomConnection))
                                {
                                    var combocheck = SlotToCheck.BottomConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedBottom > combocheck.AdjustedTop)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.BottomConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.BottomConnection);

                                        LogComboMessage("Slot " + SlotToCheck.BottomConnection.SlotNumber + " will combo!");
                                    }
                                }
                            }
                        }
                    }
                    #endregion

                    #region Same Rule
                    // Check for Same rule
                    if (HasRule(TripleTriadRule.Same))
                    {
                        List<BoardSlot> SameValues = new List<BoardSlot>();
                        // Check if connections are equal
                        if (boardslot.TopConnection != null)
                        {
                            var competingcard = boardslot.TopConnection.Card;
                            if (mycard.AdjustedTop == competingcard.AdjustedBottom)
                            {
                                SameValues.Add(boardslot.TopConnection);
                            }
                        }
                        if (boardslot.LeftConnection != null)
                        {
                            var competingcard = boardslot.LeftConnection.Card;
                            if (mycard.AdjustedLeft == competingcard.AdjustedRight)
                            {
                                SameValues.Add(boardslot.LeftConnection);
                            }
                        }
                        if (boardslot.RightConnection != null)
                        {
                            var competingcard = boardslot.RightConnection.Card;
                            if (mycard.AdjustedRight == competingcard.AdjustedLeft)
                            {
                                SameValues.Add(boardslot.RightConnection);
                            }
                        }
                        if (boardslot.BottomConnection != null)
                        {
                            var competingcard = boardslot.BottomConnection.Card;
                            if (mycard.AdjustedBottom == competingcard.AdjustedTop)
                            {
                                SameValues.Add(boardslot.BottomConnection);
                            }
                        }

                        List<BoardSlot> VisitedSlots = new List<BoardSlot>();
                        Stack<BoardSlot> SlotsToCombo = new Stack<BoardSlot>();
                        // If we have a match, time to do logic
                        if (SameValues.Count() > 1)
                        {
                            // Get each matching side
                            foreach (var match in SameValues)
                            {
                                // The Combo rule only applies if the card belongs to the opponent
                                if (match.Card.IsOpponents)
                                {
                                    // First off, count the capture that we get for this card
                                    captures++;

                                    // Next, add this boardslot to the ToVisit stack
                                    SlotsToCombo.Push(match);

                                    // Also add this to the VisitedSlots list so we don't come back to it
                                    VisitedSlots.Add(match);

                                    LogComboMessage("Slot " + match.SlotNumber + " will combo!");
                                }
                            }
                            // Check all our combo possibilities
                            while (SlotsToCombo.Count >= 1)
                            {
                                var SlotToCheck = SlotsToCombo.Pop();
                                // Check for a combo on the top
                                if (SlotToCheck.TopConnection != null && !VisitedSlots.Contains(SlotToCheck.TopConnection))
                                {
                                    var combocheck = SlotToCheck.TopConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedTop > combocheck.AdjustedBottom)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.TopConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.TopConnection);

                                        LogComboMessage("Slot " + SlotToCheck.TopConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the left
                                if (SlotToCheck.LeftConnection != null && !VisitedSlots.Contains(SlotToCheck.LeftConnection))
                                {
                                    var combocheck = SlotToCheck.LeftConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedLeft > combocheck.AdjustedRight)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.LeftConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.LeftConnection);

                                        LogComboMessage("Slot " + SlotToCheck.LeftConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the right
                                if (SlotToCheck.RightConnection != null && !VisitedSlots.Contains(SlotToCheck.RightConnection))
                                {
                                    var combocheck = SlotToCheck.RightConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedRight > combocheck.AdjustedLeft)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.RightConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.RightConnection);

                                        LogComboMessage("Slot " + SlotToCheck.RightConnection.SlotNumber + " will combo!");
                                    }
                                }
                                // Check for a combo on the bottom
                                if (SlotToCheck.BottomConnection != null && !VisitedSlots.Contains(SlotToCheck.BottomConnection))
                                {
                                    var combocheck = SlotToCheck.BottomConnection.Card;
                                    if (combocheck.IsOpponents &&
                                        SlotToCheck.Card.AdjustedBottom > combocheck.AdjustedTop)
                                    {
                                        // Capture the combo
                                        captures++;

                                        // Add the captured card to the SlotsToCombo stack
                                        SlotsToCombo.Push(SlotToCheck.BottomConnection);

                                        // Also add it to the no visit stack
                                        VisitedSlots.Add(SlotToCheck.BottomConnection);

                                        LogComboMessage("Slot " + SlotToCheck.BottomConnection.SlotNumber + " will combo!");
                                    }
                                }
                            }
                        }
                    }
                    #endregion

                    // Check for a capture on the top
                    // Only check if not part of the Plus or Same rule already
                    if (boardslot.TopConnection != null)
                    {
                        var competingcard = boardslot.TopConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedTop > competingcard.AdjustedBottom) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedTop == 1 && competingcard.AdjustedBottom == 10)))
                        {
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            blocked = blocked + competingcard.AdjustedBottom + mycard.AdjustedTop;
                        }
                        if (boardslot.TopConnection.IsOpen())
                        {
                            //exposed = exposed + mycard.AdjustedTop;
                            exposed = 10 - mycard.AdjustedTop;
                            topexposed = mycard.AdjustedTop;
                        }
                    }
                    else
                    {
                        blocked = blocked + mycard.AdjustedTop;
                    }
                    // Check for a capture on the left
                    // Only check if not part of the Plus or Same rule already
                    if (boardslot.LeftConnection != null)
                    {
                        var competingcard = boardslot.LeftConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedLeft > competingcard.AdjustedRight) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedLeft == 1 && competingcard.AdjustedRight == 10)))
                        {
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            blocked = blocked + competingcard.AdjustedRight + mycard.AdjustedLeft;
                        }
                        if (boardslot.LeftConnection.IsOpen())
                        {
                            //exposed = exposed + mycard.AdjustedLeft;
                            exposed = 10 - mycard.AdjustedLeft;
                            leftexposed = mycard.AdjustedLeft;
                        }
                    }
                    else
                    {
                        blocked = blocked + mycard.AdjustedLeft;
                    }
                    // Check for a capture on the right
                    // Only check if not part of the Plus or Same rule already
                    if (boardslot.RightConnection != null)
                    {
                        var competingcard = boardslot.RightConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedRight > competingcard.AdjustedLeft) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedRight == 1 && competingcard.AdjustedLeft == 10)))
                        {
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            blocked = blocked + competingcard.AdjustedLeft + mycard.AdjustedRight;
                        }
                        if (boardslot.RightConnection.IsOpen())
                        {
                            //exposed = exposed + mycard.AdjustedRight;
                            exposed = 10 - mycard.AdjustedRight;
                            rightexposed = mycard.AdjustedRight;
                        }
                    }
                    else
                    {
                        blocked = blocked + mycard.AdjustedRight;
                    }
                    // Check for a capture on the bottom
                    // Only check if not part of the Plus or Same rule already
                    if (boardslot.BottomConnection != null)
                    {
                        var competingcard = boardslot.BottomConnection.Card;
                        if (competingcard.IsOpponents &&
                            ((mycard.AdjustedBottom > competingcard.AdjustedTop) ||
                            (HasRule(TripleTriadRule.Fallen_Ace) && mycard.AdjustedBottom == 1 && competingcard.AdjustedTop == 10)))
                        {
                            // If the card is the opponent's and my bottom is higher than their top, it's a capture
                            captures++;
                        }
                        if (competingcard.IsMine)
                        {
                            // If the card below is mine, the top of that card and the bottom of my card will be blocked
                            blocked = blocked + competingcard.AdjustedTop + mycard.AdjustedBottom;
                        }
                        if (boardslot.BottomConnection.IsOpen())
                        {
                            // If the bottom is open, that number is free for the taking, so make sure we know it's exposed
                            //exposed = exposed + mycard.AdjustedBottom;
                            exposed = 10 - mycard.AdjustedBottom;
                            bottomexposed = mycard.AdjustedBottom;
                        }
                    }
                    else
                    {
                        // If the connection is null, that means there's no slot there so that side is blocked
                        blocked = blocked + mycard.AdjustedBottom;
                    }
                    // Add the move to the list of possible moves
                    PossibleMoves.Add(new Move(boardslot.SlotNumber, GetIndexOfMyCard(mycard), captures, blocked, exposed, topexposed, bottomexposed, leftexposed, rightexposed));
                }
            }
            #endregion

            #region Final Move Selection
            Final:
            // On the first move, we don't want to play a card with a weak side in the middle, 
            // so let's make sure we're smarter than that
            if (NumOfMyCards == 5)
            {
                PossibleMoves.RemoveAll(r => r.SlotNumber == 4 && r.Captures == 0);
            }

            // If the Order ruleset is in play, make sure we're only playing the correct card
            if (HasRule(TripleTriadRule.Order))
            {
                if (NumOfMyCards == 5)
                {
                    LogMessage("Order rule in play, checking all possible plays with card 1...");
                    PossibleMoves.RemoveAll(r => r.CardIndex != 0);
                }
                if (NumOfMyCards == 4)
                {
                    LogMessage("Order rule in play, checking all possible plays with card 2...");
                    PossibleMoves.RemoveAll(r => r.CardIndex != 1);
                }
                if (NumOfMyCards == 3)
                {
                    LogMessage("Order rule in play, checking all possible plays with card 3...");
                    PossibleMoves.RemoveAll(r => r.CardIndex != 2);
                }
                if (NumOfMyCards == 2)
                {
                    LogMessage("Order rule in play, checking all possible plays with card 4...");
                    PossibleMoves.RemoveAll(r => r.CardIndex != 3);
                }
                if (NumOfMyCards == 1)
                {
                    LogMessage("Order rule in play, checking all possible plays with card 5...");
                    PossibleMoves.RemoveAll(r => r.CardIndex != 4);
                }
            }

            if (HasRule(TripleTriadRule.Chaos))
            {
                LogMessage("Chaos rule in play, can only play card " + (TripleTriad.GetPlayableChaosCard) + "...");
                PossibleMoves.RemoveAll(r => r.CardIndex != TripleTriad.GetPlayableChaosCard);
            }

            #region Indolent Imperial Strategy (Scion Deck)

            bool minfilia = false;
            // If the opponent went first and we have Minfilia, we need to play her
            if (Core.Player.HasTarget && Core.Target.NpcId == 1011789 && NumOfMyCards == 5 && HaveSpecificCard(9, 3, 5, 8) && Board.Count(r => !r.IsOpen()) > 0)
            {
                LogMessage("Opponent went first, playing Minfilia...");
                PossibleMoves.RemoveAll(r => r.CardIndex != GetIndexOfMyCard(9, 3, 5, 8));
                // Set minfilia flag to true so we don't do other logic that might remove her
                minfilia = true;
            }
            #endregion

            // Don't play our 4-5 star cards on the first or second turn unless it leads to a capture
            // Don't run this logic if we have the rules Order or Chaos, as we don't get to choose what we play
            if (!minfilia && NumOfMyCards > 3 && !HasRule(TripleTriadRule.Order) && !HasRule(TripleTriadRule.Chaos))
            {
                PossibleMoves.RemoveAll(r => r.Captures == 0 && GetMyCardByIndex(r.CardIndex).STARS > 3);
            }

            // Check min/max exposed values
            if (HasRule(TripleTriadRule.Reverse))
            {
                if (Settings.MaxExposedLeft >= 1)
                    PossibleMoves.RemoveAll(r => r.LeftExposedValue > Settings.MaxExposedLeft && r.Captures == 0);
                if (Settings.MaxExposedRight >= 1)
                    PossibleMoves.RemoveAll(r => r.RightExposedValue > Settings.MaxExposedRight && r.Captures == 0);
                if (Settings.MaxExposedTop >= 1)
                    PossibleMoves.RemoveAll(r => r.TopExposedValue > Settings.MaxExposedTop && r.Captures == 0);
                if (Settings.MaxExposedBottom >= 1)
                    PossibleMoves.RemoveAll(r => r.BottomExposedValue > Settings.MaxExposedBottom && r.Captures == 0);
            }
            else
            {
                if (Settings.MinExposedLeft >= 1)
                {
                    if (Debug)
                    {
                        foreach (var move in PossibleMoves.Where(r => r.LeftExposedValue != 0 && r.LeftExposedValue < Settings.MinExposedLeft && r.Captures == 0))
                        {
                            LogDebug("MinExposedLeft | Captures: " + move.Captures + ", Blocked: " + move.Blocked + ", Exposed: " + move.Exposed + ", Card: " + move.CardIndex + ", Slot: " + move.SlotNumber + ", Top Exposed: " + move.TopExposedValue + ", Bottom Exposed: " + move.BottomExposedValue + ", Left Exposed: " + move.LeftExposedValue + ", Right Exposed: " + move.RightExposedValue);
                        }
                    }
                    PossibleMoves.RemoveAll(r => r.LeftExposedValue != 0 && r.LeftExposedValue < Settings.MinExposedLeft && r.Captures == 0);
                }

                if (Settings.MinExposedRight >= 1)
                {
                    if (Debug)
                    {
                        foreach (var move in PossibleMoves.Where(r => r.RightExposedValue != 0 && r.RightExposedValue < Settings.MinExposedRight && r.Captures == 0))
                        {
                            LogDebug("MinExposedRight | Captures: " + move.Captures + ", Blocked: " + move.Blocked + ", Exposed: " + move.Exposed + ", Card: " + move.CardIndex + ", Slot: " + move.SlotNumber + ", Top Exposed: " + move.TopExposedValue + ", Bottom Exposed: " + move.BottomExposedValue + ", Left Exposed: " + move.LeftExposedValue + ", Right Exposed: " + move.RightExposedValue);
                        }
                    }
                    PossibleMoves.RemoveAll(r => r.RightExposedValue != 0 && r.RightExposedValue < Settings.MinExposedRight && r.Captures == 0);
                }

                if (Settings.MinExposedTop >= 1)
                {
                    if (Debug)
                    {
                        foreach (var move in PossibleMoves.Where(r => r.TopExposedValue != 0 && r.TopExposedValue < Settings.MinExposedTop && r.Captures == 0))
                        {
                            LogDebug("MinExposedTop | Captures: " + move.Captures + ", Blocked: " + move.Blocked + ", Exposed: " + move.Exposed + ", Card: " + move.CardIndex + ", Slot: " + move.SlotNumber + ", Top Exposed: " + move.TopExposedValue + ", Bottom Exposed: " + move.BottomExposedValue + ", Left Exposed: " + move.LeftExposedValue + ", Right Exposed: " + move.RightExposedValue);
                        }
                    }
                    PossibleMoves.RemoveAll(r => r.TopExposedValue != 0 && r.TopExposedValue < Settings.MinExposedTop && r.Captures == 0);
                }

                if (Settings.MinExposedBottom >= 1)
                {
                    if (Debug)
                    {
                        foreach (var move in PossibleMoves.Where(r => r.BottomExposedValue != 0 && r.BottomExposedValue < Settings.MinExposedBottom && r.Captures == 0))
                        {
                            LogDebug("MinExposedBottom | Captures: " + move.Captures + ", Blocked: " + move.Blocked + ", Exposed: " + move.Exposed + ", Card: " + move.CardIndex + ", Slot: " + move.SlotNumber + ", Top Exposed: " + move.TopExposedValue + ", Bottom Exposed: " + move.BottomExposedValue + ", Left Exposed: " + move.LeftExposedValue + ", Right Exposed: " + move.RightExposedValue);
                        }
                    }
                    PossibleMoves.RemoveAll(r => r.BottomExposedValue != 0 && r.BottomExposedValue < Settings.MinExposedBottom && r.Captures == 0);
                }
            }

            // Remove any non-valid moves
            PossibleMoves.RemoveAll(r => !r.IsMoveValid);

            // Sort our moves by most captures, then by most exposed, then by least blocked
            // ThenByDescending = Max value first
            IOrderedEnumerable<Move> sort;
            if (HasRule(TripleTriadRule.Reverse))
            {
                sort = PossibleMoves.OrderByDescending(o => o.Captures).ThenBy(o => o.Exposed).ThenByDescending(o => o.Blocked);
            }
            else
            {
                //sort = PossibleMoves.OrderByDescending(o => o.Captures).ThenByDescending(o => o.Exposed).ThenBy(o => o.Blocked);
                // New strat: Sort by captures, then by minimized (10 - exposedside), then by blocked values
                sort = PossibleMoves.OrderByDescending(o => o.Captures).ThenBy(o => o.Exposed).ThenBy(o => o.Blocked);
            }
            // Output our move options
            if (Debug)
            {
                var i = 0;
                foreach (var move in sort)
                {
                    LogDebug("Move " + i + "| Captures: " + move.Captures + ", Blocked: " + move.Blocked + ", Exposed: " + move.Exposed + ", Card: " + move.CardIndex + ", Slot: " + move.SlotNumber + ", Top Exposed: " + move.TopExposedValue + ", Bottom Exposed: " + move.BottomExposedValue + ", Left Exposed: " + move.LeftExposedValue + ", Right Exposed: " + move.RightExposedValue);
                    i++;
                }
            }
            // Output stats
            LogMessage("Choosing best move from " + sort.Count() + " possible moves...");

            // Return if the window isn't open
            if (!TripleTriad.IsOpen) return;

            // Get the top move on the sorted deck, which is our best move
            Move bestmove = null;
            if (sort.Count() > 0)
            {
                bestmove = sort.FirstOrDefault();
            }
            else
            {
                LogMessage("Advanced fine tuning settings too restrictive or Triple Triad window closing, could not play move!");
                //var tempcard = GetIndexOfMyCard(MyCards.Where(r => r.IsMine).FirstOrDefault());
                //var tempslot = Board.Where(r => r.IsOpen()).FirstOrDefault().SlotNumber;
                //bestmove = new Move(tempslot, tempcard, 0, 0, 0);
            }

            // Play our best move
            if (TripleTriad.IsOpen && bestmove != null)
            {
                TripleTriad.PlayCard(bestmove.CardIndex, (uint)bestmove.SlotNumber);
            }
            #endregion
        }

        public Composite GetRoot()
        {
            return Root;
        }

        public static readonly string line = AgentTripleTriad.LocalizedChallengeText;
        public override Composite Root
        {
            get
            {
                return _root ?? (_root =
                            new PrioritySelector(
                                new Decorator(r => Talk.DialogOpen,
                                    new Action(r => Talk.Next())
                                ),
                                new Decorator(r => TripleTriadRequest.IsOpen,
                                    new Sequence(
                                        new Action(r => TripleTriadRequest.Challenge()),
                                        new Sleep(1, 2)
                                    )
                                ),
                                new Decorator(r => SelectIconString.IsOpen,
                                    new Sequence(
                                        new Action(r => SelectIconString.ClickLineContains(line)),
                                        new Sleep(1, 2)
                                    )
                                ),
                                new Decorator(r => TripleTriadResult.IsOpen,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            ClearRules();
                                            TripleTriadResult.Rematch();
                                        }),
                                        new Sleep(1, 2)
                                    )
                                ),
                                new Decorator(r => TripleTriadSelDeck.IsOpen,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            if (!Settings.Recommended)
                                            {
                                                TripleTriadSelDeck.SelectDeck((uint)Settings.Deck - 1);
                                            }
                                            else
                                            {
                                                TripleTriadSelDeck.SelectRecommended();
                                            }

                                        }),
                                        new Sleep(4, 6)
                                    )
                                ),
                                new Decorator(r => TripleTriad.IsOpen,
                                    new PrioritySelector(
                                        new Decorator(r => NeedToGetRules,
                                            new Action(r => UpdateRules())
                                        ),
                                        new Decorator(r => !TripleTriad.IsMyTurn,
                                            new Action(r =>
                                            {
                                                if (!NeedToUpdate)
                                                {
                                                    NeedToUpdate = true;
                                                    //LogMessage("It's not our turn!");
                                                }
                                            })
                                        ),
                                        new Decorator(r => TripleTriad.IsMyTurn,
                                            new Sequence(
                                                new Sleep(2, 5),
                                                new Action(r =>
                                                {
                                                    if (TripleTriad.IsOpen)
                                                    {
                                                        //if (NeedToUpdate)
                                                        //{
                                                        //LogMessage("It's our turn, let's update our cards!");
                                                        UpdateCards();
                                                        NeedToUpdate = false;
                                                        //}
                                                        MakeBestMove();
                                                    }
                                                }),
                                                new Sleep(3, 6)
                                            )
                                        )
                                    )
                                ),
                                new Decorator(r => NotNPCTime && Vector3.Distance(Core.Player.Location, new Vector3(Settings.NpcLocation)) < 4 && MovementManager.IsMoving, new Action(r => MovementManager.MoveForwardStop())),
                                new Decorator(r => !NotNPCTime && WorldManager.ZoneId == (uint)Settings.NpcMap && Vector3.Distance(Core.Player.Location, new Vector3(Settings.NpcLocation)) < 4 && (!Core.Player.HasTarget || Core.Target.NpcId == Settings.NpcId),
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            MovementManager.MoveForwardStop();
                                            LogMessage("Challenging " + Settings.NpcName + " to a Triple Triad match!");
                                            GameObjectManager.GetObjectByNPCId((uint)Settings.NpcId).Interact();
                                        }
                                        ),
                                        new Sleep(1, 2)
                                    )
                                ),
                                new Decorator(r => WorldManager.ZoneId == (uint)Settings.NpcMap && Vector3.Distance(Core.Player.Location, new Vector3(Settings.NpcLocation)) > 4, CommonBehaviors.MoveAndStop(r => new Vector3(Settings.NpcLocation), 2f, true, Settings.NpcName)),
                                new Decorator(r => WorldManager.ZoneId != (uint)Settings.NpcMap && !Core.Player.IsCasting,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            if (!WorldManager.AetheryteIdsForZone((uint)Settings.NpcMap).Any(aetheryte => WorldManager.HasAetheryteId(aetheryte.Item1)))
                                            {
                                                LogMessage("No available teleport to our NPC.");
                                                TreeRoot.Stop();
                                            }
                                            foreach (var aetheryte in WorldManager.AetheryteIdsForZone((uint)Settings.NpcMap))
                                            {
                                                LogMessage("Teleporting to NPC...");
                                                WorldManager.TeleportById(aetheryte.Item1);
                                                break;
                                            }
                                        }
                                        ),
                                        new Sleep(15, 20)
                                    )
                                ),
                                new Decorator(r => NotNPCTime,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            var npc = TripleTriadNPCs.FirstOrDefault(o => o.NpcId == Settings.NpcId);
                                            if (npc != null && npc.StartTime > 0 && npc.EndTime > 0)
                                            {
                                                LogMessage("Waiting for the time window for " + npc.Name + " to open at " + npc.StartTime + ":00.  Current Eorzea Time: " + WorldManager.EorzaTime.ToString(@"HH:mm"));
                                            }
                                        }),
                                        new Wait(30, r => !NotNPCTime, new ActionAlwaysSucceed())
                                    )
                                )
                            )
                        );
            }
        }
    }
}
