﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System.Text.RegularExpressions;
using Clio.Utilities;
using ff14bot;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ff14bot.Managers;
using RemoteProcedureCalls;

namespace TripleTriHard
{
    public partial class TripleTriHardForm : Form
    {
        public static TripleTriHardSettings Settings = TripleTriHardSettings.Instance;

        public string npcName { get; set; }
        public int npcId { get; set; }
        public string npcLocation { get; set; }
        public int npcMap { get; set; }
        public int deck { get; set; }

        public TripleTriHardForm()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Name
            textBox1.Text = Settings.NpcName;
            npcName = Settings.NpcName;
            // NpcId
            textBox2.Text = Settings.NpcId.ToString();
            npcId = Settings.NpcId;
            // Location
            textBox3.Text = Settings.NpcLocation.ToString();
            npcLocation = Settings.NpcLocation;
            // MapId
            textBox4.Text = Settings.NpcMap.ToString();
            npcMap = Settings.NpcMap;
            // Deck
            comboBox1.Text = Settings.Deck.ToString();
            deck = Settings.Deck;
            // Recommended
            if (Settings.Recommended)
            {
                comboBox1.Enabled = false;
                checkBox1.Checked = true;
            }
            else
            {
                comboBox1.Enabled = true;
                checkBox1.Checked = false;
            }
            // Min and Max Exposed
            MinTop.Text = Settings.MinExposedTop.ToString();
            MinLeft.Text = Settings.MinExposedLeft.ToString();
            MinRight.Text = Settings.MinExposedRight.ToString();
            MinBottom.Text = Settings.MinExposedBottom.ToString();
            MaxTop.Text = Settings.MaxExposedTop.ToString();
            MaxLeft.Text = Settings.MaxExposedLeft.ToString();
            MaxRight.Text = Settings.MaxExposedRight.ToString();
            MaxBottom.Text = Settings.MaxExposedBottom.ToString();

            // MGP per hour
            MgpPerHourLabel.Text = Math.Floor(TripleTriHard.MgpPerHour).ToString();

            // Play Time
            PlayTimeLabel.Text = String.Format("{0:%d} day(s) {0:%h} hr {0:%m} min {0:%s} sec", TripleTriHard.TimeSinceStart);

            // Start Timer
            timer1.Start();
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            // Name
            Settings.NpcName = npcName;
            // NpcId
            Settings.NpcId = npcId;
            // Location
            Settings.NpcLocation = npcLocation;
            // MapId
            Settings.NpcMap = npcMap;
            // Deck
            Settings.Deck = Convert.ToInt32(comboBox1.Text);
            // Recommended
            Settings.Recommended = checkBox1.Checked;
            // Min and Max Exposed
            Settings.MinExposedTop = Convert.ToInt32(MinTop.Text);
            Settings.MinExposedLeft = Convert.ToInt32(MinLeft.Text);
            Settings.MinExposedRight = Convert.ToInt32(MinRight.Text);
            Settings.MinExposedBottom = Convert.ToInt32(MinBottom.Text);
            Settings.MaxExposedTop = Convert.ToInt32(MaxTop.Text);
            Settings.MaxExposedLeft = Convert.ToInt32(MaxLeft.Text);
            Settings.MaxExposedRight = Convert.ToInt32(MaxRight.Text);
            Settings.MaxExposedBottom = Convert.ToInt32(MaxBottom.Text);
            Settings.Save();

            // Stop timer
            timer1.Stop();

            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            using (Core.Memory.TemporaryCacheState(false))
            {
                GameObjectManager.Update();
                if (!Core.Player.HasTarget) return;
                // Name
                textBox1.Text = Core.Target.Name;
                npcName = Core.Target.Name;
                // NpcId
                textBox2.Text = Core.Target.NpcId.ToString();
                npcId = (int)Core.Target.NpcId;
                // Location
                npcLocation = Core.Target.Location.ToString().Remove(0, 1);
                npcLocation = npcLocation.Remove(npcLocation.Length - 1, 1);
                textBox3.Text = npcLocation;
                // MapId
                textBox4.Text = WorldManager.ZoneId.ToString();
                npcMap = WorldManager.ZoneId;
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                comboBox1.Enabled = false;
            }
            else
            {
                comboBox1.Enabled = true;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // MGP per hour
            MgpPerHourLabel.Text = Math.Floor(TripleTriHard.MgpPerHour).ToString();

            // Play Time
            PlayTimeLabel.Text = String.Format("{0:%d} day(s) {0:%h} hr {0:%m} min {0:%s} sec", TripleTriHard.TimeSinceStart);
        }
    }
}
