﻿/*
TripleTriHard is licensed under a
Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.

You should have received a copy of the license along with this
work. If not, see <http://creativecommons.org/licenses/by-nc-sa/4.0/>.

Orginal work done by kagamihiiragi17, maintenance and updates by mastahg.
                                                                                 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ff14bot.Helpers;
using Newtonsoft.Json;

namespace TripleTriHard
{
    public class TripleTriHardSettings : JsonSettings
    {
        [JsonIgnore]
        private static TripleTriHardSettings _instance;
        public static TripleTriHardSettings Instance { get { return _instance ?? (_instance = new TripleTriHardSettings("TripleTriHardSettings")); } }
        public TripleTriHardSettings(string filename) : base(Path.Combine(CharacterSettingsDirectory, "TripleTriHard.json")) { }

        [Setting, DefaultValue("King Elmer III")]
        public string NpcName { get; set; }
        [Setting, DefaultValue(1011055)]
        public int NpcId { get; set; }
        [Setting, DefaultValue("-115.7703, -3.267695, 86.71704")]
        public string NpcLocation { get; set; }
        [Setting, DefaultValue(144)]
        public int NpcMap { get; set; }
        [Setting, DefaultValue(1)]
        public int Deck { get; set; }
        [Setting, DefaultValue(false)]
        public bool Recommended { get; set; }
        [Setting, DefaultValue(0)]
        public int MinExposedLeft { get; set; }
        [Setting, DefaultValue(0)]
        public int MinExposedRight { get; set; }
        [Setting, DefaultValue(0)]
        public int MinExposedTop { get; set; }
        [Setting, DefaultValue(0)]
        public int MinExposedBottom { get; set; }
        [Setting, DefaultValue(0)]
        public int MaxExposedLeft { get; set; }
        [Setting, DefaultValue(0)]
        public int MaxExposedRight { get; set; }
        [Setting, DefaultValue(0)]
        public int MaxExposedTop { get; set; }
        [Setting, DefaultValue(0)]
        public int MaxExposedBottom { get; set; }
    }
}
