﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using ff14bot.AClasses;
using ff14bot.Helpers;

namespace QuestDev
{

    public class QuestDevTools : BotPlugin
    {
        public override void Dispose()
        {
            CloseForm();
        }

        public override string Author
        {
            get { return "Mastahg"; }
        }

        public override Version Version
        {
            get { return new Version(0, 0, 1); }
        }

        public override string Name
        {
            get { return "QuestDevTools"; }
        }

		
		internal Thread _guiThread;
        internal Form1 form;
        public void ToggleGUI()
        {
            if (_guiThread == null || !_guiThread.IsAlive)
            {
                _guiThread = new Thread(() =>
                {
                    form = new Form1();
                    form.ShowDialog();

                })
                {
                    IsBackground =  true
                };

                _guiThread.SetApartmentState(ApartmentState.STA);
                _guiThread.Start();
            }
            else
            {
                CloseForm();
            }
        }

        public override void OnButtonPress()
        {
            ToggleGUI();
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public override string ButtonText
        {
            get { return "Toggle"; }
        }

        private void CloseForm()
        {
            if (form != null && form.Visible)
            {
                // close the form on the forms thread
                form.Invoke((MethodInvoker)delegate { form.Close(); });
            }
        }
        public override void OnShutdown()
        {
            CloseForm();
        }

        private Form1 Dialog;

			
		 public override void OnDisabled()
        {
            CloseForm();
        }	
			
        public override void OnEnabled()
        {
			ToggleGUI();
        }
    }

}
