﻿//
// LICENSE:
// This work is licensed under the
//     Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
// also known as CC-BY-NC-SA.  To view a copy of this license, visit
//      http://creativecommons.org/licenses/by-nc-sa/3.0/
// or send a letter to
//      Creative Commons // 171 Second Street, Suite 300 // San Francisco, California, 94105, USA.
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Clio.Utilities;
using Clio.XmlEngine;
using ff14bot.Behavior;
using ff14bot.Managers;
using ff14bot.Navigation;
using TreeSharp;
using Action = TreeSharp.Action;

namespace ff14bot.NeoProfiles.Tags
{



    [XmlElement("ClimbHill")]
    class ClimbHill : ProfileBehavior
    {
        private bool _done;
        [XmlAttribute("Start")]
        public Vector3 StartPoint { get; set; }

        [XmlAttribute("End")]
        public Vector3 EndPoint { get; set; }



        [XmlAttribute("Name")]
        public string Name { get; set; }


        [DefaultValue(1)]
        [XmlAttribute("Distance")]
        public float Distance { get; set; }


        public bool ReachedStart = false;
        public override bool IsDone { get { return _done; } }

        protected override Composite CreateBehavior()
        {
            return new PrioritySelector(



                new Decorator(r => !ReachedStart, GetToStart),
                new Decorator(r => ReachedStart, Climbhill)
                
                
                
                
                );

        }

        public Composite Climbhill
        {
            get
            {
                return new PrioritySelector(
                    new Decorator(r=> EndPoint.Distance(Core.Player.Location) < .5f,new Action(r=> { _done = true;MovementManager.MoveForwardStop(); })),
                    new Action(r =>
                    {
                        
                        Core.Player.Face(EndPoint);
                        MovementManager.MoveForwardStart();

                        Vector3 Start = Core.Player.Location;
                        var distance = 1;
                        var End = new Vector3((float)(Start.X + Math.Sin(Core.Player.Heading) * distance), Start.Y, (float)(Start.Z + Math.Cos(Core.Player.Heading) * distance));
                        Vector3 hit;
                        if (WorldManager.Raycast(Start,End,out hit))
                            MovementManager.Jump();


                    })
                    
                    );
            }
        }
        public Composite GetToStart
        {
            get
            {
                return new PrioritySelector(
                    
                    
                    CommonBehaviors.MoveAndStop(r=>StartPoint,1.5f,true,"Moving to start point"),
                    new Decorator(r => StartPoint.Distance(Core.Player.Location) <= 1.5f, new Action(z => ReachedStart =true))
                    
                    
                    );
            }
        }

        /// <summary>
        /// This gets called when a while loop starts over so reset anything that is used inside the IsDone check
        /// </summary>
        protected override void OnResetCachedDone()
        {
            ReachedStart = false;
            _done = false;
        }

        protected override void OnDone()
        {
            // Force a stop!
            Navigator.PlayerMover.MoveStop();
        }
    }
}
